#include<bits/stdc++.h>
using namespace std;

long long n,x[50010],y[50010];
long long a[10000010],maxSt=1,br=0;

int main(){
 cin>>n;

 for(int i=0 ; i<n ; i++){
    cin>>x[i]>>y[i];
    for(int j=x[i] ; j<y[i] ; j++){
        a[j]++;
        if(a[j]>maxSt){
            maxSt=a[j];
            br=0;
        }
        if(a[j]==maxSt){
            br++;
        }
    }
 }

 cout<<maxSt<<endl<<br++;
 return 0;
}

